%define pkg_name bigfin

Summary: SKYRING ceph provider
Name: rhscon-ceph
Version: 0.0.40
Release: 1%{?dist}
Source0: %{pkg_name}-%{version}.tar.gz
License: ASL 2.0
Group: Development/Libraries
Url: https://github.com/skyrings/bigfin

BuildRequires: golang
BuildRequires: python-devel
BuildRequires: python-setuptools

Requires: rhscon-core
Requires: salt-master >= 2015.5.5

%description
SKYRING Ceph provider

%prep
%setup -n %{pkg_name}-%{version}

%build
make build-special
make pybuild

%install
install -m 755 -d $RPM_BUILD_ROOT/%{_var}/lib/skyring/providers
install -D bigfin $RPM_BUILD_ROOT/%{_var}/lib/skyring/providers
install -m 755 -d $RPM_BUILD_ROOT/%{_sysconfdir}/skyring/providers.d/
install -Dm 0644 conf/ceph.conf $RPM_BUILD_ROOT/%{_sysconfdir}/skyring/providers.d/ceph.conf
install -m 755 -d $RPM_BUILD_ROOT/srv/salt/_modules
install -D backend/salt/sls/* $RPM_BUILD_ROOT/srv/salt/
install -d $RPM_BUILD_ROOT/%{python2_sitelib}/bigfin
install -D backend/salt/python/bigfin/* $RPM_BUILD_ROOT/%{python2_sitelib}/bigfin/
install -Dm 0644 salt_module/ceph.py $RPM_BUILD_ROOT/srv/salt/_modules
install -Dm 0644 salt_module/mon_remote.py $RPM_BUILD_ROOT/srv/salt/_modules
install -Dm 0644 backend/salt/python/bigfin/utils.py $RPM_BUILD_ROOT/srv/salt/_modules
install -Dm 0644 conf/ceph.dat.sample $RPM_BUILD_ROOT/%{_sysconfdir}/skyring/providers.d/ceph.dat
install -Dm 0644 provider/ceph.evt $RPM_BUILD_ROOT/%{_sysconfdir}/skyring/providers.d/ceph.evt
chmod -x $RPM_BUILD_ROOT/srv/salt/add_ceph_mon.sls
chmod -x $RPM_BUILD_ROOT/srv/salt/prepare_ceph_osd.sls
chmod -x $RPM_BUILD_ROOT/srv/salt/start_ceph_mon.sls
chmod -x $RPM_BUILD_ROOT/%{python2_sitelib}/bigfin/__init__.py
chmod -x $RPM_BUILD_ROOT/%{python2_sitelib}/bigfin/saltwrapper.py
chmod -x $RPM_BUILD_ROOT/%{python2_sitelib}/bigfin/utils.py

%files
%{_var}/lib/skyring/providers/bigfin
%config(noreplace) %{_sysconfdir}/skyring/providers.d/ceph.conf
/srv/salt/*
%{python2_sitelib}/bigfin/*
/srv/salt/_modules/*
%config(noreplace) %{_sysconfdir}/skyring/providers.d/ceph.dat
%config(noreplace) %{_sysconfdir}/skyring/providers.d/ceph.evt

%doc README.md

%changelog
* Fri Aug 05 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.40-1
- Changes
  - BZ#1362510, 1334470
  - Decrypt and use configurations from core

* Mon Aug 01 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.39-1
- Changes
  - Re-calculate pgnum if pgnum < osd count
  - Complete task if create pool times out and pool added through event
  - Update DB even if the pool created by event
  - Update storage profile of pool while syncing and via event

* Thu Jul 28 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.38-1
- Changes
  - Removed re-calculation of pgnum while expand cluster
  - Corrected the size field while rbd creation
  - Modofied cluster stats to not use json o/p

* Wed Jul 27 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.37-1
- Changes
  - Fixed threshold analysis pool total size
  - Changed the disk size and journal sizes as float64

* Sat Jul 23 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.36-1
- Changes
  - Corrected the pgnum calculation logic
  - Fixed an issue with weight calculation logic

* Fri Jul 22 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.35-1
- Changes
  - Checking storage profile also during retrival of slu for PG num calc
  - Fixed the calculation of pool utilization
  - Add crush weight when creating the osd device in crush map

* Wed Jul 20 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.34-1
- Changes
  - Sync stats on entity creation
  - Corrected utilization descriptions
  - Added configuration to not create crush map on reboot
  - Update rbd pool name while pool rename

* Wed Jul 13 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.33-1
- Changes
  - Added a workaround for BZ#1355970

* Tue Jul 12 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.32-1
- Changes
  - storage profile support while import cluster
  - added description field for cluster configuration labels
  - change the calamari server when mon node goes down
  - no need to check if already logged into calamari as retry is available

* Fri Jul 08 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.31-1
- Changes
  - Dismiss all the alerts when an entity is deleted
  - Cleanup of spec file
  - Rename storage profile general to default

* Fri Jul 01 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.30-1
- Changes
  - Code clean up related to db session creation

* Tue Jun 28 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.29-1
- Changes
  - Fixed an issue while numeric conversion

* Tue Jun 28 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.28-1
- Changes
  - Added nil check before closing http response body
  - BZ#1341655 Corrected storage pool editing logic
  - Increased the time out to 5 mins
  - BZ#1339480 Fix the ecprofile creation issue

* Fri Jun 24 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.27-1
- Changes
  - Mark cluster creation task as failed if min mons are not created
  - Corrected OSD and MON service status
  - Close response body after reading data from it - calamari api calls
  - Link monitor status with its host alarm count
  - BZ#1339480, Fixed issue with EC pool creation
  - Added salt module for emitting rbd create/delete/resize events
  - Added scheduler for triggering rbd events
  - Handle rbd add/delete/resize events

* Mon Jun 20 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.26-1
- Changes
  - Fixed the filtering criteria for host fetch from DB

* Mon Jun 20 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.25-1
- Changes
  - Fixed wrong logging of timeout message
  - Disable calamari start during expand cluster

* Sat Jun 18 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.24-1
- Changes
  - Check if minimum required mons provided while create cluster
  - Fetch stats using calamari apis
  - Added timestamp to utilization
  - Removed call to append services to node
  - Removed size field while ec pool creation
  - Use pending SSD with available space as SSD while expand cluster
  - Added weight field to crush configuration

* Tue Jun 14 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.23-1
- Changes
  - Update service count in nodes
  - Update node service state when changed

* Mon Jun 13 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.22-1
- Changes
  - Sync block devices while import cluster flow
  - Crush rule update while expand cluster flow

* Tue Jun 07 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.21-1
- Changes
  - crush rule related changes
  - changed the default no of journals on SSD to 4
  - rpc function for disk hierarchy
  - made maximum possible no of journals on SSD disk as configurable
  - corrected calamari start code to use cmd.run
  - fixed an issue with journal mapping for SSDs
  - added osdjournal and reweight to osd options

* Mon May 30 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.20-1
- Changes
  - Fixed an issue with node roles while import cluster

* Fri May 27 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.19-1
- Changes
  - Salt client creation made local (performance improvement)
  - Removed fetching for mons during getting nodes for cluster import

* Mon May 23 2016 Timothy Asir Jeyasingh <tjeyasin@redhat.com> - 0.0.18-1
- Changes
  - Fix type conversion issue for poolid in cephapi backend
  - Fix calamari accessibility issue
  - Fix nil pointer exception in osd addition handler

* Sun May 22 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.17-1
- Changes
  - Removed unwanted calamari start old style

* Fri May 20 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.16-1
- Changes
  - Added rbd utilization for monitoring
  - Start calamari on only one mon node
  - Handle alert for rbd utilization threshold breach
  - Corrected initialization of mgo sessions
  - Added cluster percent utilization
  - Added mon and pg counts
  - Monitor status based counts

* Mon May 16 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.15-1
- Changes
  - SSL mode integration with calamari
  - notifications configuration while import cluster
  - edit pool support

* Wed May 11 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.14-1
- Changes
  - Fixed issues with pool and osd event handlers

* Fri May 06 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.13-1
- Changes
  - Fixed updation of OSD to DB when event received
  - Handle ceph pool add/delete events
  - Sync PG Summary to SLUs
  - Added failed node details while import cluster in task steps
  - Enabled journal mapping while expand cluster

* Wed May 04 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.12-1
- Changes
  - Enabled logging of provisioner task details
  - BZ#1332782

* Sat Apr 30 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.11-1
- Changes
  - Modified calamari event tags
  - Import cluster feature
  - Fixed duplicate addition of OSDs

* Fri Apr 29 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.10-1
- Changes
  - Enhanced expand cluster flow to use ceph installer
  - Added service details rpc function
  - Added handlers for cluster and OSD events
  - Added handlers for mon state change events

* Fri Apr 22 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.9-1
- Changes
  - fixed rpmlint issues
  - storage profile utilization correlation
  - receive event types details loaded in skyring core
  - node role
  - add list of notifications for subscription
  - alert for ceph logical resources
  - figure out disk info from data mount point of OSD
  - create cluster integration with ceph 2.0
  - journal support while create cluster
  - Removed dependency on ceph binaries

* Tue Mar 29 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.8-1
- Changes
  - Logical resources threshold alerting
  - Link storage profiles with CRUSH rules
  - Cluster sync jobs

* Thu Mar 24 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.7-1
- Changes
  - Use ceph api for EC pool creation
  - RPC function for getting cluster configuration
  - Support for editing storage pools

* Wed Mar 16 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.6-14
- Changes
  - Corrected ceph.conf entries

* Tue Mar 15 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.6-13
- Changes
  - ceph-installer integration
  - Stop task rpc function
  - pg error count
  - Corrected cluster creation flow

* Fri Mar 11 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.6-12
- Changes
  - Corrected object count
  - pg summary in osd
  - Corrected pgnum calculation for EC pools

* Mon Mar 07 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.6-11
- Changes
  - Default EC profile creation
  - ceph-installer integration framework
  - Creation of erasure coded pool
  - Pool utilization
  - Object status

* Tue Mar 01 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.6-10
- Changes
  - Rebased latest skyring-common

* Mon Feb 29 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.6-9
- Changes
  - Block device management apis create/delete/resize
  - Monitoring changes
  - Remove the default created pool

* Wed Feb 24 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.6-8
- Corrected spec file to copy salt module files

* Tue Feb 23 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.6-7
- Changes
  - Cluster status/state changes
  - Save monitoring info into entities
  - Auto expand cluster on disk additions to nodes

* Sun Feb 21 2016 Timothy Asir <tjeyasin@redhat.com> - 0.0.6-6
- Fixed the issue with salt module for ceph

* Wed Feb 17 2016 Timothy Asir <tjeyasin@redhat.com> - 0.0.6-5
- Added API to retrieve PG summary

* Tue Feb 16 2016 Shubhendu Tripathi <shtripat@redhat.com> - 0.0.6-4
- Added object count feature

* Mon Feb 15 2016 Timothy Asir <tjeyasin@redhat.com> - 0.0.6-3
- Changes
  - Introduced timeout for async tasks
  - Introduced common module skyring-common
  - Introduced different cluster states
  - Introduced salt module for salt calls
  - Logical resources utilization
  - Added context in log messages

* Tue Feb 02 2016 Timothy Asir <tjeyasin@redhat.com> - 0.0.6-2
- Changes
  - BZ#1296464
  - Feature to provide OSD details
  - Update cluster status after creation
  - Monitoring related stabilization

* Thu Jan 28 2016 Shubhendu Tripathi <shtripat> - 0.0.6-1
- Introduced below features
  - Monitoring framework
  - Recalculate pgnum/pgpnum while expand cluster
  - Few bug fixes and code refactors

* Fri Jan 22 2016 Timothy Asir <tjeyasin@redhat.com> - 0.0.5-0.1.alpha1
- Build alpha1 - v0.0.5-0.1.alpha1 (code refresh)

* Fri Jan 08 2016 Kanagaraj Mayilsamy <kmayilsa@redhat.com> - 0.0.4-0.1.alpha1
- Build alpha1 - v0.0.4-0.1.alpha1

* Tue Jan 05 2016 Kanagaraj Mayilsamy <kmayilsa@redhat.com> - 0.0.3-0.1.alpha1
- Build alpha1 - v0.0.3-0.1.alpha1

* Thu Dec 31 2015 Kanagaraj Mayilsamy <kmayilsa@redhat.com> - 0.0.2-0.1.alpha1
- Build alpha1 - v0.0.2-0.1.alpha1

* Wed Dec 23 2015 Kanagaraj Mayilsamy <kmayilsa@redhat.com> - 0.0.1-2
- Changed the providers dir to /var/lib/skyring/providers/

* Tue Dec 22 2015 Kanagaraj Mayilsamy <kmayilsa@redhat.com> - 0.0.1-1
- Initial build
